package ADS;

public class KListe {
  Listenzelle Kopf=null, Ende=null;  int n=0;

  public KListe() {
  }

  public int count() {
    return n;
  }

  public boolean istPos(Listenzelle i) {
    return i!=null;
  }

  public Listenzelle first() {
    return Kopf;
  }

  public Listenzelle last() {
    return Ende;
  }

  public Elementtyp getElement(Listenzelle i) {
    if (i!=null) return i.inhalt; else return null;
  }

  public void elemTausch(Listenzelle i, Listenzelle j) {
    Listenzelle e=new Listenzelle();
    if (istPos(i) && istPos(j)) {
      e.inhalt=i.inhalt; i.inhalt=j.inhalt;
      j.inhalt=e.inhalt;
    }
  }

  public Listenzelle prev(Listenzelle i) {
    if (istPos(i)) return i.prev; else return last();
  }

  public Listenzelle next(Listenzelle i) {
    if (istPos(i)) return i.next; else return first();
  }

  public Listenzelle nachb(int k, Listenzelle i) {
    int j=1; while ((j<=k) && istPos(i)) {
      i=i.next; j++;
    }
    return i;
  }

  public void add(Elementtyp e) {
    Listenzelle neu=new Listenzelle(e); n++;
    if (Kopf==null){ Kopf=neu; Ende=Kopf; }
    else { Ende.next=neu; neu.prev=Ende; Ende=neu; }
  }

  public void insert(Elementtyp e, Listenzelle i) {
    if (istPos(i)) {
      Listenzelle neu=new Listenzelle(e); n++;
      neu.prev=i.prev;  i.prev=neu;
      neu.next=i;
      if (neu.prev!=null) neu.prev.next=neu; else Kopf=neu;
    } else add(e);
  }

  public void remove(Listenzelle i) {
    Listenzelle h;
    if (istPos(i)) {
      h=i.next; if (i.prev!=null) i.prev.next=h; else Kopf=h;
      h=i.prev; if (i.next!=null) i.next.prev=h; else Ende=h;
      i=null; n--;
    }
  }

  public Listenzelle locate(String s) {
    String S;
    Listenzelle j=new Listenzelle(); boolean found=false;
    j=first();
    while (!found && istPos(j)) {
      S=j.inhalt.getSchluessel();
      found=(S.equals(s));
      if (!found) j=next(j);
    }
    return j;
  }

  final class Listenzelle {
    Elementtyp inhalt;
    Listenzelle next, prev;

    public Listenzelle() {  inhalt=null; next=null; prev=null; }

    public Listenzelle(Elementtyp e) { inhalt=e; next=null; prev=null; }
  }

}