package ADS;

public class PriorBaum extends Heap {
  protected int breite, blattE;

  public PriorBaum(int b) {
    breite=b;
    int[] hInt=Elementtyp.mod2Hoch(breite); if (hInt[0]>0) breite=2*hInt[2];
    maxAnz=2*breite-1; n=maxAnz; blattE=maxAnz/2; Speicher=new Object[maxAnz];
    for (int i=0; i<blattE; i++) setElement(null,i);
    for (int i=blattE; i<maxAnz; i++) setElement(new AVLBaum(),i);
  }

  public int splittwert(int i) {
    int[] temp=Elementtyp.mod2Hoch(i+1);
    return (2*temp[0]+1)*breite/(2*temp[2]);
  }

  private boolean einfueg(LIntervall iv, int i) {
    boolean ok=false; LIntervall ivIst, ivTemp;
    if (i>=blattE) ok=((AVLBaum) getElement(i)).einfuegen(iv);
    else { ivIst=(LIntervall) getElement(i);
      if (ivIst==null) setElement(iv,i);
      else {
        if (iv.liRd<ivIst.liRd) { ivTemp=ivIst; ivIst=iv; iv=ivTemp; }
        if (iv.reRd<=splittwert(i)) ok=einfueg(iv,2*i+1);
        else ok=einfueg(iv,2*i+2);
      }
    }
    return ok;
  }

  public boolean einfuegen(LIntervall iv) {
    boolean ok=false;
    if (iv.istIn(new LIntervall(0,breite))) ok=einfueg(iv,0);
    return ok;
  }

  private boolean entfern(LIntervall iv, int i) {
    boolean ok=false; LIntervall ivIst;
    String s=iv.getSchluessel();
    if (i>=blattE) ok=((AVLBaum) getElement(i)).entfernen(s);
    else {  ivIst=(LIntervall) getElement(i);
      if (ivIst!=null)
        if (s.equals(ivIst.getSchluessel())) { setElement(null,i); ok=true; }
        else
          if (iv.reRd<=splittwert(i)) ok=entfern(iv,2*i+1);
          else ok=entfern(iv,2*i+2);
    }
    return ok;
  }

  public boolean entfernen(LIntervall IV) {
    boolean ok=false;
    if (IV.istIn(new LIntervall(0,breite))) ok=entfern(IV,0);
    return ok;
  }

  public void knReport(int i,LIntervall vglIV,AVLBaum erg) {
  /** Falls die Wurzel (Knoten 0) die Nadel enthlt, wird zur Ergebnisbergabe
   *  ein AVLBaum erzeugt und die Hilfsprozedur Report fr die Wurzel, die Nadel
   *  und den Ergebnisbaum aufgerufen.
   */
    LIntervall iv; Object o;
    if (istPos(i)) {
      o=getElement(i);
      if (o!=null) {
        if (i<blattE) iv=(LIntervall) o;
        else iv=(LIntervall)((AVLKnoten)((AVLBaum) o).minSchlKn()).getInhalt();
        if (!(iv==null || iv.liRd>=vglIV.reRd))
          if (iv.reRd>vglIV.liRd) {
            erg.einfuegen(iv);
            knReport(2*i+1,vglIV,erg);
            if (splittwert(2*i)>=vglIV.liRd) knReport(2*i,vglIV,erg);
          }
      }
    }
  }

}