package ADS;

import java.io.*;
import javax.swing.*;

public class StreamSort {
  int Anz=0;
  String Arbeitsverzeichnis;
  File f, F[]=new File[4];
  DataInputStream  IS[]=new DataInputStream[2];   DataInputStream in;
  DataOutputStream OS[]=new DataOutputStream[2];  DataOutputStream out;
  public boolean Abbr=false;
  int[] z=new int[2];
  ElementtypI x,y,el;
  JTextArea ausg; String s;

  public StreamSort(File f, String Arbeitsverzeichnis, JTextArea ausg) {
    this.f=f;
    try { in=new DataInputStream(new BufferedInputStream(
                                   new FileInputStream(f)));
    }
    catch (IOException ex) {Abbr=true;}
    if (!Abbr) {
      this.Arbeitsverzeichnis=Arbeitsverzeichnis;
      this.ausg=ausg;
      int i;
      for (i=0; i<4; i++) F[i]=new File(Arbeitsverzeichnis+
                                             "Mist"+String.valueOf(i)+".Dat");
      fileInit1(); i=0;
      do {
        el=ElementtypI.laden(in);
        if (el!=null) { el.speichern(OS[i]);
          s=el.getSchluessel();
          Anz++; i=(i+1)%2;
        }
      } while (el!=null);
      try { OS[0].close(); OS[1].close(); } catch (IOException iox) { }
    }
  }

  public StreamSort(File f, String Arbeitsverzeichnis) {
    this.f=f;
    try { in=new DataInputStream(new BufferedInputStream(
                                   new FileInputStream(f)));
    }
    catch (IOException ex) {Abbr=true;}
    if (!Abbr) {
      this.Arbeitsverzeichnis=Arbeitsverzeichnis;
      ausg=null;
      int i;
      for (i=0; i<4; i++) F[i]=new File(Arbeitsverzeichnis+
                                             "Mist"+String.valueOf(i)+".Dat");
      fileInit1(); i=0;
      do {
        el=ElementtypI.laden(in);
        if (el!=null) { el.speichern(OS[i]);
          s=el.getSchluessel();
          Anz++; i=(i+1)%2;
        }
      } while (el!=null);
      try { OS[0].close(); OS[1].close(); } catch (IOException iox) { }
    }
  }


  private void fileInit1() {
    try {
      OS[0]=new DataOutputStream(new BufferedOutputStream(
                                                   new FileOutputStream(F[0])));
      OS[1]=new DataOutputStream(new BufferedOutputStream(
                                                   new FileOutputStream(F[1])));
      IS[0]=new DataInputStream(new BufferedInputStream(
                                                    new FileInputStream(F[2])));
      IS[1]=new DataInputStream(new BufferedInputStream(
                                                    new FileInputStream(F[3])));
      Abbr=false;
    }
    catch (IOException e) {Abbr=true;}
  }

  private void fileInit2() {
    try {
      OS[0]=new DataOutputStream(new BufferedOutputStream(
                                                   new FileOutputStream(F[2])));
      OS[1]=new DataOutputStream(new BufferedOutputStream(
                                                   new FileOutputStream(F[3])));
      IS[0]=new DataInputStream(new BufferedInputStream(
                                                    new FileInputStream(F[0])));
      IS[1]=new DataInputStream(new BufferedInputStream(
                                                    new FileInputStream(F[1])));
      Abbr=false;
    }
    catch (IOException e) {Abbr=true;}
  }

  private void Rest(int posIn, int posOut, int tlLg) {
    Abbr=false;
    while (!Abbr && z[posIn]<tlLg) {
      x=ElementtypI.laden(IS[posIn]); Abbr=(x==null);
      if (!Abbr) {
        z[posIn]++; x.speichern(OS[posOut]);
        if (ausg!=null) ausg.append(x.getSchluessel()+", ");
      }
    }
  }

  public void sortieren() {
    int inAkt, outAkt, tlLg=1;
    boolean odd=false, fertig=false;
    while (tlLg<Anz) { //neuer Schritt
      if (odd) fileInit1(); else fileInit2();
      odd=!odd;  outAkt=0;
      do {//neue Mischung
        z[0]=0; z[1]=0; inAkt=0;
        x=ElementtypI.laden(IS[inAkt]); Abbr=x==null;
        if (Abbr) Rest((inAkt+1)%2,outAkt,tlLg);
        else {
          z[inAkt]++; inAkt=(inAkt+1)%2;
          while (!Abbr && z[inAkt]<tlLg) {//Mischprozess
            y=ElementtypI.laden(IS[inAkt]);
            Abbr=(y==null);
            if (!Abbr) {
              z[inAkt]++;
              if (x.getSchluessel().compareTo(y.getSchluessel())<0) {
                x.speichern(OS[outAkt]);
                if (ausg!=null) ausg.append(x.getSchluessel()+", ");
                x=y; inAkt=(inAkt+1)%2;
              }
              else {
                y.speichern(OS[outAkt]);
                if (ausg!=null) ausg.append(y.getSchluessel()+", ");
              }
            }
          }
          x.speichern(OS[outAkt]);
          if (ausg!=null) ausg.append(x.getSchluessel()+", ");
          Rest((inAkt+1)%2,outAkt,tlLg);
        }
        outAkt=(outAkt+1)%2;
        if (ausg!=null) ausg.append("\n");
      } while (!Abbr);
      try { OS[0].close(); OS[1].close(); IS[0].close(); IS[1].close(); }
      catch (IOException iox) { }
      tlLg=2*tlLg;
      if (ausg!=null) ausg.append("\n");
    }
    try {
      out=new DataOutputStream(new BufferedOutputStream(
                                 new FileOutputStream(f)));
      if (odd) fileInit1(); else fileInit2();
      for (int i=0; i<Anz; i++) {
        x=ElementtypI.laden(IS[0]);
        if (x!=null) x.speichern(out);
      }
      IS[0].close(); out.close();
    }
    catch (IOException ex) {}
  }

}