package adsuebungen;

import ADS.*;
import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import javax.swing.border.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author unbekannt
 * @version 1.0
 */

public class Dialog_AVLBaum extends JDialog {
  JPanel panel1 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  XYLayout xYLayout1 = new XYLayout();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JButton EndeBtn = new JButton();
  JScrollPane jScrollPane1 = new JScrollPane();
  String[] TabKopf = new String[] {
      "0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16",
      "17","18","19","20","21","22","23","24","25","26","27","28","29","30","31"};
  String[][] Tab = new String[15][32];
  JTable jTable1 = new JTable(Tab,TabKopf);
  TitledBorder titledBorder1;
  TitledBorder titledBorder2;
  AVLBaum baum=new AVLBaum();
  JTextField textfeld = new JTextField();
  JButton OKBtn = new JButton();

  public Dialog_AVLBaum(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  public Dialog_AVLBaum() {
    this(null, "", false);
  }

  private void jbInit() throws Exception {
    titledBorder1 = new TitledBorder("");
    titledBorder2 = new TitledBorder("");
    panel1.setLayout(borderLayout1);
    this.getContentPane().setLayout(xYLayout1);
    jLabel1.setRequestFocusEnabled(true);
    jLabel1.setText("+S fr einfuegen(S), -S fr entfernen(S), ?S fr suchen(S)");
    jLabel2.setText("Eingaben");
    EndeBtn.setEnabled(true);
    EndeBtn.setAlignmentX( (float) 0.0);
    EndeBtn.setDebugGraphicsOptions(0);
    EndeBtn.setActionCommand("Ende");
    EndeBtn.setContentAreaFilled(true);
    EndeBtn.setText("Ende");
    EndeBtn.addActionListener(new Dialog_AVLBaum_EndeBtn_actionAdapter(this));
    xYLayout1.setWidth(881);
    xYLayout1.setHeight(377);
    jTable1.setFont(new java.awt.Font("Dialog", 0, 10));
    jTable1.setBorder(BorderFactory.createRaisedBevelBorder());
    jScrollPane1.setEnabled(true);
    jScrollPane1.setForeground(Color.black);
    jScrollPane1.setBorder(titledBorder2);
    jScrollPane1.setDebugGraphicsOptions(0);
    textfeld.setText("");
    textfeld.addActionListener(new Dialog_AVLBaum_textfeld_actionAdapter(this));
    OKBtn.setActionCommand("OKBtn");
    OKBtn.setText("Ausfhren");
    OKBtn.addActionListener(new Dialog_AVLBaum_OKBtn_actionAdapter(this));
    this.getContentPane().add(panel1, new XYConstraints(75, 49, -1, -1));
    this.getContentPane().add(jScrollPane1,          new XYConstraints(3, 72, 875, 273));
    this.getContentPane().add(jLabel1, new XYConstraints(25, 43, -1, -1));
    this.getContentPane().add(jLabel2, new XYConstraints(24, 13, 69, -1));
    this.getContentPane().add(textfeld,  new XYConstraints(89, 10, 174, -1));
    this.getContentPane().add(OKBtn,  new XYConstraints(323, 10, 118, -1));
    this.getContentPane().add(EndeBtn,       new XYConstraints(394, 349, 92, -1));
    jScrollPane1.getViewport().add(jTable1, null);
    jTable1.setColumnSelectionAllowed(true);
  }

  void EndeBtn_actionPerformed(ActionEvent e) {
    dispose();
  }

  void OKBtn_actionPerformed(ActionEvent e1) {
    int i; boolean ok=false;
    String S = textfeld.getText();
    JOptionPane jOptPan = new JOptionPane();
    if (S.length() > 0) {
      char c = S.charAt(0);
      S = S.substring(1);
      ElementtypS e=new ElementtypS(S);
      jTable1.clearSelection();
      switch (c) {
        case '+':
          if(!baum.einfuegen(e)) jOptPan.showMessageDialog(this,
                "Element '"+S+"' schon im AVLBaum vorhanden.");
          else ok=true;
          break;
        case '-':
          if(!baum.entfernen(e.getSchluessel())) jOptPan.showMessageDialog(this,
                "Element '"+S+"' konnte nicht entfernt werden!");
          else jOptPan.showMessageDialog(this,"'"+S+"' wurde entfernt...");
          break;
        case '?':
          Elementtyp d=baum.suchen(e.getSchluessel());
          if(d==null || !d.getSchluessel().equals(e.getSchluessel()))
            jOptPan.showMessageDialog(this,"Element '"+S+"' wurde nicht gefunden!");
          else ok=true;
          break;
      }
      if(ok && (c=='+' || c=='?')){
        int[] iKn=baum.EtagOrd(e.getSchluessel(),baum.Wurzel);
        jTable1.changeSelection(3*iKn[0],
              iKn[1]*baum.ZweiHoch(baum.Hoehe(baum.Wurzel))/baum.ZweiHoch(iKn[0]+1),false,false);
      }
      if(c=='+' || c=='-')
        baum.BaumAusgabe(jTable1,baum.Wurzel);
    }
  }
  //...
  void textfeld_actionPerformed(ActionEvent e) {
    OKBtn_actionPerformed(e);
  }
}


class Dialog_AVLBaum_EndeBtn_actionAdapter implements java.awt.event.ActionListener {
  Dialog_AVLBaum adaptee;

  Dialog_AVLBaum_EndeBtn_actionAdapter(Dialog_AVLBaum adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.EndeBtn_actionPerformed(e);
  }
}

class Dialog_AVLBaum_OKBtn_actionAdapter implements java.awt.event.ActionListener {
  Dialog_AVLBaum adaptee;

  Dialog_AVLBaum_OKBtn_actionAdapter(Dialog_AVLBaum adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.OKBtn_actionPerformed(e);
  }
}

class Dialog_AVLBaum_textfeld_actionAdapter implements java.awt.event.ActionListener {
  Dialog_AVLBaum adaptee;

  Dialog_AVLBaum_textfeld_actionAdapter(Dialog_AVLBaum adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.textfeld_actionPerformed(e);
  }
}
