package adsuebungen;

import ADS.*;
import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import javax.swing.border.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author unbekannt
 * @version 1.0
 */

public class Dialog_HashKett extends JDialog {
  JPanel panel1 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  XYLayout xYLayout1 = new XYLayout();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JButton OKBtn = new JButton();
  JButton EndeBtn = new JButton();
  JTextField textfeld = new JTextField();
  TitledBorder titledBorder1;
  TitledBorder titledBorder2;
  String[] Zeilen={"0:  ","1:  ","2:  ","3:  ","4:  ","5:  ","6:  ","7:  ","8:  ","9:  ",
      "10: ","11: ","12: ","13: ","14: ","15: ","16: ","17: ","18: "};
  JList Ausg = new JList(Zeilen);
  HashKett hashkette=new HashKett(19);
  JScrollPane jScrollPane1 = new JScrollPane();

  public Dialog_HashKett(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  public Dialog_HashKett() {
    this(null, "", false);
  }

  private void jbInit() throws Exception {
    titledBorder1 = new TitledBorder("");
    titledBorder2 = new TitledBorder("");
    panel1.setLayout(borderLayout1);
    this.getContentPane().setLayout(xYLayout1);
    jLabel1.setText("+S fr einfuegen(S), -S fr entfernen(S), ?S fr suchen(S)");
    jLabel2.setRequestFocusEnabled(true);
    jLabel2.setText("Eingabe");
    OKBtn.setActionCommand("OK");
    OKBtn.setText("Ausfhren");
    OKBtn.addActionListener(new Dialog_HashKett_OKBtn_actionAdapter(this));
    EndeBtn.setEnabled(true);
    EndeBtn.setAlignmentX( (float) 0.0);
    EndeBtn.setDebugGraphicsOptions(0);
    EndeBtn.setActionCommand("Ende");
    EndeBtn.setContentAreaFilled(true);
    EndeBtn.setText("Ende");
    EndeBtn.addActionListener(new Dialog_HashKett_EndeBtn_actionAdapter(this));
    textfeld.setNextFocusableComponent(OKBtn);
    textfeld.setText("");
    xYLayout1.setWidth(435);
    xYLayout1.setHeight(491);
    Ausg.setAutoscrolls(true);
    Ausg.setMaximumSize(new Dimension(25, 380));
    Ausg.setFixedCellHeight(-1);
    Ausg.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    Ausg.setVisibleRowCount(19);
    this.getContentPane().add(panel1, new XYConstraints(75, 49, -1, -1));
    this.getContentPane().add(jLabel1,   new XYConstraints(10, 42, -1, -1));
    this.getContentPane().add(jLabel2,     new XYConstraints(11, 14, 69, -1));
    this.getContentPane().add(textfeld,     new XYConstraints(79, 9, 184, 26));
    this.getContentPane().add(OKBtn,  new XYConstraints(286, 8, 122, -1));
    this.getContentPane().add(Ausg,           new XYConstraints(12, 64, 410, 256));
    this.getContentPane().add(jScrollPane1,         new XYConstraints(9, 60, 417, 344));
    this.getContentPane().add(EndeBtn,                                new XYConstraints(171, 406, 92, -1));
    jScrollPane1.getViewport().add(Ausg, null);
  }

  void EndeBtn_actionPerformed(ActionEvent e) {
    dispose();
  }

  void OKBtn_actionPerformed(ActionEvent e1) {
    int i;
    ElementtypS e;
    String S = textfeld.getText();
    JOptionPane jOptPan = new JOptionPane();
    Ausg.clearSelection();
    if (S.length() > 0) {
      char c = S.charAt(0);
      S = S.substring(1);
      e=new ElementtypS(S);
      switch (c) {
        case '+':
          if(!hashkette.einfuegen(e))
            jOptPan.showMessageDialog(this,"Element '"+S+
                                      "' schon in der Hashkette vorhanden!");
          break;
        case '-':
          if(!hashkette.entfernen(e.getSchluessel()))
            jOptPan.showMessageDialog(this,"Element '"+S+
                                      "' konnte nicht gefunden werden!");;
          break;
        case '?':
          Elementtyp d=hashkette.suchen(e.getSchluessel());
          if(d==null || !d.getSchluessel().equals(e.getSchluessel()))
            jOptPan.showMessageDialog(this,"Element '"+S+"' wurde nicht gefunden!");
          else
            Ausg.setSelectedIndex(hashkette.Hashfkt(e.getSchluessel()));
          break;
      }
      if(c=='+' || c=='-'){
        Zeilen[hashkette.Hashfkt(e.getSchluessel())]=hashkette.Ausgabe(hashkette.Hashfkt(e.getSchluessel()));
        Ausg.setListData(Zeilen);
      }
    }
  }
}


class Dialog_HashKett_EndeBtn_actionAdapter implements java.awt.event.ActionListener {
  Dialog_HashKett adaptee;

  Dialog_HashKett_EndeBtn_actionAdapter(Dialog_HashKett adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.EndeBtn_actionPerformed(e);
  }
}

class Dialog_HashKett_OKBtn_actionAdapter implements java.awt.event.ActionListener {
  Dialog_HashKett adaptee;

  Dialog_HashKett_OKBtn_actionAdapter(Dialog_HashKett adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.OKBtn_actionPerformed(e);
  }
}
