package adsuebungen;

import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import com.borland.dbswing.*;
import ADS.*;

/**
 * berschrift:   Testrahmen fr bungsprogramme zur LV  "Algorithmen u. Datenstrukturen"
 * Beschreibung:
 * Copyright:     Copyright (c) 2002
 * Organisation:  HTWK Leipzig, Fb IMN
 * @author Prof. Dr. G. Ngler, edited by Matthias Jauernig
 * @version 1.0
 */

public class Dialog_SegBaum extends JDialog {
  JPanel panel1=new JPanel();
  XYLayout xYLayout1 = new XYLayout();
  JLabel jLabel1 = new JLabel();
  XYLayout xYLayout2 = new XYLayout();
  JTextField Eingfeld = new JTextField();
  JButton EingBtn = new JButton();
  JLabel jLabel2 = new JLabel();
  JButton EndeBtn = new JButton();
  Segmentbaum sb=new Segmentbaum(16);
  String[] Ergebnisse=new String[20];
  JList liste;
  JScrollPane jScrollPane1 = new JScrollPane();
  JLabel jLabel3 = new JLabel();

  public Dialog_SegBaum(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try { jbInit(); pack(); }
    catch(Exception ex) { ex.printStackTrace();  }
  }

  public Dialog_SegBaum() {   this(null, "", false); }

  void jbInit() throws Exception {
    panel1.setLayout(xYLayout2);
    this.getContentPane().setLayout(xYLayout1);
    jLabel1.setText("Eingabe:");
    EingBtn.setSelected(true);
    EingBtn.setText("ausfhren!");
    EingBtn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        EingBtn_actionPerformed(e);
      }
    });
    jLabel2.setText("(+x1,x2  fr einfuegen([x1,x2)), -x1,x2  fr entfernen([x1,x2)),");
    EndeBtn.setText("bung beenden!");
    EndeBtn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        EndeBtn_actionPerformed(e);
      }
    });
    xYLayout1.setWidth(448);
    xYLayout1.setHeight(366);
    jLabel3.setText("  ?Nadel  fr Spiess(Nadel))");
    Eingfeld.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Eingfeld_actionPerformed(e);
      }
    });
    panel1.add(jLabel1,      new XYConstraints(15, 28, 56, -1));
    panel1.add(Eingfeld,     new XYConstraints(89, 26, 72, -1));
    panel1.add(EingBtn,      new XYConstraints(186, 25, -1, -1));
    panel1.add(jLabel2,        new XYConstraints(13, 58, 432, -1));
    panel1.add(jScrollPane1,      new XYConstraints(16, 109, 318, 200));
    panel1.add(EndeBtn, new XYConstraints(266, 329, -1, -1));
    panel1.add(jLabel3, new XYConstraints(14, 78, -1, -1));
    this.getContentPane().add(panel1,     new XYConstraints(-3, 0, 403, 360));
  }

  void EingBtn_actionPerformed(ActionEvent e) {
    LIntervall IV; boolean ok; int i,x1=0,x2=1,nadel;
    String s=Eingfeld.getText(),x1S,x2S;
    if (s.length()>0) {
      char c=s.charAt(0); s=s.substring(1); i=s.indexOf(",");
      if (c=='?') {
        try { nadel=new Integer(s).intValue(); }
        catch (Exception exc) { nadel=-1; };
        if (i==-1) {
          AVLBaum Erg=sb.spiess(nadel);
          for (i=0; i<20; i++) Ergebnisse[i]="";
          Ergebnisse[0]="Folgende der "+sb.count()+" Intervalle  enthalten "+s
                                                                          +":";
          AVLKnoten Kn=Erg.minSchlKn(); i=0;
          while (Kn!=null) {
            i++;
            Ergebnisse[i]=Kn.getSchluessel()+", ";
            Kn=Erg.nextSchl(Kn);
          }
        }
       liste= new JList(Ergebnisse);
       jScrollPane1.getViewport().add(liste, null);
      }
      else {
        x1S=s.substring(0,i);
        x2S=s.substring(i+1);
        ok=true;
        try {
          x1=new Integer(x1S).intValue();
          try { x2=new Integer(x2S).intValue(); }
          catch (Exception exc) { ok=false; };
        }
        catch (Exception exc) { ok=false; };
        if (ok) {
          IV=new LIntervall(x1,x2);
          switch (c) {
            case '+':
              ok=sb.einfuegen(IV);
              if (!ok) JOptionPane.showMessageDialog(this,
                                                      s+" ist schon vorhanden");
            break;
            case '-':
              ok=sb.entfernen(IV);
              if(!ok) JOptionPane.showMessageDialog(this,
                    s+" wurde nicht gefunden!");
            break;
          }//switch
        }//ok
      } //else von c=='?'
    }//if S.length
  }

  void EndeBtn_actionPerformed(ActionEvent e) { dispose(); }

  void Eingfeld_actionPerformed(ActionEvent e) {
    EingBtn_actionPerformed(e);
  }

}