package ADS;

import ADS.*;
/**
 * berschrift:  Classes zur LV  "Algorithmen u. Datenstrukturen"
 * Beschreibung:
 * Copyright:     Copyright (c) 2002
 * Organisation:  HTWK Leipzig, Fb IMN
 * @author Prof. Dr. G. Ngler
 * @version 1.0
 */

public class Knapsack {
  protected int[] g; protected double[] w; int n;
  public Knapsack(int[] G, double[] W) { g=G; w=W; n=g.length; }

  public int[] getOptPackung(int maxGewicht) {
  // result zhlt die einzupackenden Gegenstnde auf
    int i,j,gew,neuGew,optGew=0,aktSchranke=0;
    double maxWert=0.0;
    ElementtypRI[] Packungen=new ElementtypRI[maxGewicht+1]; // Zustnde
    ElementtypRI Zustand, neuZust;
    // int-Wert=Summe(x(i)* 2**i); double-Wert=Summe(x(i)* w[i]),
    // fr i=0,1, ..., n-1 = Gegegenstands-Nr.
    Packungen[0]=new ElementtypRI(0,0);
    for (gew=1; gew<=maxGewicht; gew++) Packungen[gew]=new ElementtypRI(0,-1);
    for (i=0; i<n; i++) {
      for (gew=aktSchranke; gew>=0; gew--) {
        Zustand=Packungen[gew]; neuGew=gew+g[i];
        if (Zustand.getInt()!=-1 && neuGew<=maxGewicht) {
          neuZust=Packungen[neuGew];
          if (neuZust.getInt()==-1
              || neuZust.getInhalt()<Zustand.getInhalt()+w[i]) {
            Packungen[neuGew]=
             new ElementtypRI(Zustand.getInhalt()+w[i],Zustand.getInt()+(1<<i));
          }
        }
      }
      aktSchranke=aktSchranke+g[i];
      if (aktSchranke>maxGewicht) aktSchranke=maxGewicht;
    }
    for (gew=0; gew<=maxGewicht; gew++)
      if (Packungen[gew].getInhalt()>maxWert) {
        maxWert=Packungen[gew].getInhalt();  optGew=gew;
      }
    int N=0;
    int H=Packungen[optGew].getInt();
    while (H!=0) { if (H % 2==1) N++; H=H>>1; }
    int[] result=new int[N];
    H=Packungen[optGew].getInt();
    i=0; j=0;
    while (H!=0) { if (H % 2==1) result[j++]=i; i++; H=H>>1; }
    return result;
  }

  public int Gewicht(int[] Packung) {
    int G=0;
    for (int z=0; z<Packung.length; z++) G=G+g[Packung[z]];
    return G;
  }

  public double Wert(int[] Packung) {
    double W=0;
    for (int z=0; z<Packung.length; z++) W=W+w[Packung[z]];
    return W;
  }

}