package ADS;

/**
 * berschrift:   Classes zur LV  "Algorithmen u. Datenstrukturen"
 * Beschreibung:
 * Copyright:     Copyright (c) 2002
 * Organisation:  HTWK Leipzig, Fb IMN
 * @author Prof. Dr. G. Ngler
 * @version 1.0
 */

public class LIntervall extends Elementtyp {
  public int liRd, reRd;

  public LIntervall(int x, int y) {liRd=x; reRd=y; }

  public String getSchluessel() {
    return "["+new String().valueOf(liRd)+", "+new String().valueOf(reRd)+")";
  }

  public boolean istIn(LIntervall iv) { return iv.liRd<=liRd && reRd<=iv.reRd; }

  public boolean hatSchnitt(LIntervall iv) {
    return (!(reRd<=iv.liRd || liRd>=iv.reRd));
  }

   public boolean enthaelt(int i) {  return liRd<=i && i<reRd;  }

}