package ADS;
/**
 * <p>Title: Schlange</p>
 * <p>Description: Implementation einer Klasse "Schlange" in Java</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: none</p>
 * @author: Matthias Jauernig
 * @version: 1.0
 */
public class Schlange extends Heap {
  protected int LeseIndex;

  public Schlange(int maxAnz){
    super(maxAnz);
    LeseIndex=0;
  }

  public void push(Object x){
    setElement(x,(LeseIndex+n++)%maxAnz); //Element setzen und n++
  }

  public Object exTop(){
    Object h = getElement(LeseIndex);
    setElement(null,LeseIndex);
    LeseIndex=(LeseIndex+1)%maxAnz; //LeseIndex inkrementieren
    n--;
    return h;
  }

  public boolean istPos(int i){
    return (LeseIndex+n>maxAnz) //feststellen, ob zirkulierend
        ?(i>=LeseIndex || i<=(LeseIndex+n-1)%maxAnz)
        :(i>=LeseIndex && i<LeseIndex+n);
  }
}