package adsuebungen;

import ADS.*;
import java.util.Calendar;
import java.io.*;
import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import javax.swing.border.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Matthias Jauernig
 * @version 1.0
 */

public class Dialog_Sort extends JDialog {
  JPanel panel1 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  XYLayout xYLayout1 = new XYLayout();
  TitledBorder titledBorder1;
  TitledBorder titledBorder2;
  JButton EndeBtn = new JButton();
  JButton WinBtn = new JButton();
  JScrollPane jScrollPane1 = new JScrollPane();
  TitledBorder titledBorder3;
  int sanz=10;
  String[][] Tab = new String[5][sanz+1];
  String[] TabKopf = new String[] {
      " ", "Auswahl", "Bubble", "Einfuege", "Merge", "Quick", "Heap", "Radix", "Bit",
      "Stream HD", "Stream FD"};
  int dLg=1000;
  JTable jT = new JTable(Tab,TabKopf);
  JButton LinBtn = new JButton();
  JOptionPane jOptPan = new JOptionPane();

  public Dialog_Sort(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  public Dialog_Sort() {
    this(null, "", false);
  }

  private void jbInit() throws Exception {
    panel1.setLayout(borderLayout1);
    this.getContentPane().setLayout(xYLayout1);
    xYLayout1.setWidth(773);
    xYLayout1.setHeight(150);
    EndeBtn.setEnabled(true);
    EndeBtn.setAlignmentX( (float) 0.0);
    EndeBtn.setBorder(BorderFactory.createEtchedBorder());
    EndeBtn.setDebugGraphicsOptions(0);
    EndeBtn.setActionCommand("Beenden");
    EndeBtn.setContentAreaFilled(true);
    EndeBtn.setText("bung beenden");
    EndeBtn.addActionListener(new Dialog_Sort_EndeBtn_actionAdapter(this));
    this.getContentPane().setBackground(Color.lightGray);
    WinBtn.setBorder(BorderFactory.createEtchedBorder());
    WinBtn.setText("Start (Windows)");
    WinBtn.addActionListener(new Dialog_Sort_WinBtn_actionAdapter(this));
    LinBtn.addActionListener(new Dialog_Sort_LinBtn_actionAdapter(this));
    LinBtn.setBorder(BorderFactory.createEtchedBorder());
    LinBtn.setText("Start (Linux)");
    this.getContentPane().add(panel1, new XYConstraints(75, 49, -1, -1));
    this.getContentPane().add(jScrollPane1,            new XYConstraints(4, 3, 768, 107));
    jScrollPane1.getViewport().add(jT, null);
    this.getContentPane().add(WinBtn,  new XYConstraints(98, 113, 111, 33));
    this.getContentPane().add(EndeBtn, new XYConstraints(561, 113, 111, 33));
    this.getContentPane().add(LinBtn, new XYConstraints(332, 113, 111, 33));

    for(int i=1;i<=5;i++)
      jT.setValueAt("n="+dLg*i,i-1,0);
  }
  void EndeBtn_actionPerformed(ActionEvent e) {
    dispose();
  }

  void LinBtn_actionPerformed(ActionEvent e) {
    String verzFD = "/mnt/floppy/";
    String verzHD = "/data/";
    jOptPan.showMessageDialog(this, "Hinweis: Legen Sie eine Diskette ein und mounten diese mit\n"+
                              "Schreibrechten nach "+verzFD+". Ebenso mssen Sie Schreibrechte auf\n"+
                              verzHD+" besitzen, um hierauf sortieren zu knnen.");
    Btn_actionPerformed(e, verzHD, verzFD);
  }

  void WinBtn_actionPerformed(ActionEvent e) {
    String verzFD = "A:\\";
    String verzHD = "C:\\";
    jOptPan.showMessageDialog(this, "Hinweis: In "+verzFD+" muss eine Diskette zum "+
                              "Beschreiben vorhanden sein.");
    Btn_actionPerformed(e, verzHD, verzFD);
  }

  void Btn_actionPerformed(ActionEvent e, String verzHD, String verzFD) {
    int anz = dLg, i, j, k;
    double start, ende;

    //########## Elementanzahl im Array festlegen ##############################
    for(i=1; i<=5; i++,anz=dLg*i) { //von anz=dLg bis anz=5*dLg
      //bentigte Instanzen erzeugen
      File fHD=new File(verzHD+"Mist00.Dat");
      File fFD=new File(verzFD+"Mist00.Dat");
      DataOutputStream outHD, outFD;
      try{ outHD = new DataOutputStream(new BufferedOutputStream(
         new FileOutputStream(fHD))); }
      catch (Exception exc){
        jOptPan.showMessageDialog(this, "Konnte nicht zugreifen auf: " + verzHD);
        return;
      }
      try{ outFD = new DataOutputStream(new BufferedOutputStream(
         new FileOutputStream(fFD))); }
      catch(Exception exc){
        jOptPan.showMessageDialog(this, "Konnte nicht zugreifen auf: "+verzFD);
        return;
      }
      SortArray L[]=new SortArray[sanz-3];
      HeapSortverf L7=new HeapSortverf(anz);
      for(j=0;j<sanz-3;j++)
        L[j]=new SortArray(anz);

      for(j=0; j<anz; j++){ //SortArrays mit zuflligen int-Werten fllen
        int zzahl=(int)Math.floor(Math.random()*(anz*2)+1);
        for(k=0;k<sanz-3;k++)
          L[k].add(new ElementtypI(zzahl));
        L7.add(new ElementtypI(zzahl));
        (new ElementtypI(zzahl)).speichern(outHD);
        (new ElementtypI(zzahl)).speichern(outFD);
      }
      //schlieen, bevor korrekt mit StreamSort sortiert werden kann
      try{ outHD.close();
           outFD.close(); }
      catch(Exception exc){
        jOptPan.showMessageDialog(this, "Fehler beim Schlieen, breche ab.");
        return;
      }

      StreamSort L8=new StreamSort(fHD,verzHD);
      StreamSort L9=new StreamSort(fFD,verzFD);

      //########## Sortieren ###################################################
      for(j=0;j<sanz;j++){
        start=Calendar.getInstance().getTime().getTime();
        switch(j){
          case 0: L[0].AuswahlSort();                break;
          case 1: L[1].BubbleSort();                 break;
          case 2: L[2].EinfuegeSort();               break;
          case 3: L[3].MergeSort();                  break;
          case 4: L[4].QuickSort(0,L[4].count()-1);  break;
          case 5: L7.sortieren();                    break;
          case 6: L[5].RadixSort();                  break;
          case 7: L[6].BitSort(0,L[6].count()-1,16); break;
          case 8: L8.sortieren();                    break;
          case 9: L9.sortieren();                    break;
          default:
            jOptPan.showMessageDialog(this, "Sortieralgo noch nicht implementiert.");
        }
        ende=Calendar.getInstance().getTime().getTime();
        jT.setValueAt((ende-start)/1000+" Sek.",i-1,j+1);
      }
      //########## prfen, ob die Sortierungen quivalent sind #################
      DataInputStream inHD, inFD;
      try{ inHD = new DataInputStream(new BufferedInputStream(
           new FileInputStream(fHD))); }
      catch(Exception exc){
        jOptPan.showMessageDialog(this, "Konnte nicht zugreifen auf: "+verzHD);
        return;
      }
      try{ inFD = new DataInputStream(new BufferedInputStream(
           new FileInputStream(fFD))); }
      catch(Exception exc){
        jOptPan.showMessageDialog(this, "Konnte nicht zugreifen auf: "+verzFD);
        return;
      }

      for(j=0;j<anz;j++){
        String S[]=new String[sanz];
        for(k=0;k<sanz-3;k++)
          S[k]=((ElementtypI)L[k].getElement(j)).getSchluessel();
        S[sanz-3]=((ElementtypI)L7.getElement(j)).getSchluessel();//HeapSort
        Elementtyp e1=ElementtypI.laden(inHD);//StreamSort HD
        if(e1!=null)
          S[sanz-2]=e1.getSchluessel();
        else S[sanz-2]="null";
        e1=ElementtypI.laden(inFD);//StreamSort FD
        if(e1!=null)
          S[sanz-1]=e1.getSchluessel();
        else S[sanz-1]="null";

        for(k=0;k<sanz-1;k++)
          if(!S[k].equals(S[k+1])){
            jOptPan.showMessageDialog(this, "Sortierte Arrays unterscheiden sich!\n ('"+
                                      S[k]+"' != '"+S[k+1]+"') -> "+"Abbruch...");
            return;
          }
      }
      try{ inHD.close();
           inFD.close(); }
      catch(Exception exc){
        jOptPan.showMessageDialog(this, "Fehler beim Schlieen, breche ab.");
        return;
      }
    }
  }
}


class Dialog_Sort_EndeBtn_actionAdapter implements java.awt.event.ActionListener {
  Dialog_Sort adaptee;

  Dialog_Sort_EndeBtn_actionAdapter(Dialog_Sort adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.EndeBtn_actionPerformed(e);
  }
}

class Dialog_Sort_WinBtn_actionAdapter implements java.awt.event.ActionListener {
  Dialog_Sort adaptee;

  Dialog_Sort_WinBtn_actionAdapter(Dialog_Sort adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.WinBtn_actionPerformed(e);
  }
}

class Dialog_Sort_LinBtn_actionAdapter implements java.awt.event.ActionListener {
  Dialog_Sort adaptee;

  Dialog_Sort_LinBtn_actionAdapter(Dialog_Sort adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.LinBtn_actionPerformed(e);
  }
}
